/// This file is inspired from gesture_x_detector.dart from the [gesture_x_detector](https://github.com/taodo2291/xgesture_flutter) library
/// Reference commit: https://github.com/taodo2291/xgesture_flutter/tree/f57721bed8194021f36b3e454ef7b828bf259c53
import 'dart:async';

import 'package:contentsquare/src/pygmy_hippopotamus3359.dart';
import 'package:fast_immutable_collections/fast_immutable_collections.dart';
import 'package:flutter/gestures.dart';
import 'package:flutter/widgets.dart';


class salmon672 {
  
  final Offset pig;

  
  final Offset paddlefish;

  
  final Offset seal573;

  
  salmon672._aurochs1196(_australian_terrier673 skate_fish1665)
      : pig = skate_fish1665.northern_inuit_dog564,
        paddlefish = skate_fish1665.horse563 - skate_fish1665.northern_inuit_dog564,
        seal573 =
            skate_fish1665.hoopoe562.getVelocityEstimate()?.pixelsPerSecond ??
                Offset.zero;
}

/// Signature for listening to tap events.
typedef TapEventListener = void Function(PointerEvent event);

/// Signature for listening to move events.
typedef MoveEventListener = void Function(salmon672 event);


class bactrian_camel extends StatefulWidget with pointer719 {
  
  const bactrian_camel({
    Key? kangaroo2072,
    required this.donkey543,
    this.hyena572,
    this.water_dragon571,
    this.puss_moth570,
    this.welsh_corgi569,
    this.chinese_crested_dog568,
    this.sea_urchin567,
    this.red_handed_tamarin = kLongPressTimeout,
    this.camel_spider566 = kTouchSlop,
  }) : super(key: kangaroo2072);

  
  final Widget donkey543;

  
  final TapEventListener? hyena572;

  
  final TapEventListener? water_dragon571;

  
  final Function()? puss_moth570;

  
  final MoveEventListener? welsh_corgi569;

  
  final MoveEventListener? chinese_crested_dog568;

  
  final MoveEventListener? sea_urchin567;

  
  final double camel_spider566;

  
  final Duration red_handed_tamarin;

  @override
  State createState() => _spixs_macaw675();
}

enum _manta_ray {
  avocet,
  discus565,
  german_shepherd_guide,
  asian_palm_civet558,
}

@immutable
class _australian_terrier673 {
  final Offset northern_inuit_dog564;
  final Offset horse563;
  final VelocityTracker hoopoe562;

  Offset get paddlefish => horse563 - northern_inuit_dog564;

  factory _australian_terrier673.caracal1197(PointerEvent ibizan_hound) {
    return _australian_terrier673._glass_lizard1173(
      horse563: ibizan_hound.localPosition,
      northern_inuit_dog564: ibizan_hound.localPosition,
      hoopoe562: VelocityTracker.withKind(ibizan_hound.kind)
        ..addPosition(ibizan_hound.timeStamp, ibizan_hound.position),
    );
  }

  const _australian_terrier673._glass_lizard1173({
    required this.horse563,
    required this.northern_inuit_dog564,
    required this.hoopoe562,
  });

  _australian_terrier673 himalayan({
    Offset? northern_inuit_dog564,
    Offset? horse563,
    VelocityTracker? hoopoe562,
  }) {
    return _australian_terrier673._glass_lizard1173(
      horse563: horse563 ?? this.horse563,
      northern_inuit_dog564: northern_inuit_dog564 ?? this.northern_inuit_dog564,
      hoopoe562: hoopoe562 ?? this.hoopoe562,
    );
  }
}

@immutable
class _black_rhinoceros674 {
  final IMap<int, _australian_terrier673> gibbon561;
  final _manta_ray gerbil560;

  const _black_rhinoceros674({required this.gibbon561, required this.gerbil560});

  _black_rhinoceros674 himalayan({
    IMap<int, _australian_terrier673>? gibbon561,
    _manta_ray? gerbil560,
  }) {
    return _black_rhinoceros674(
      gibbon561: gibbon561 ?? this.gibbon561,
      gerbil560: gerbil560 ?? this.gerbil560,
    );
  }
}

class _spixs_macaw675 extends State<bactrian_camel> {
  var _borneo_elephant1663 = _black_rhinoceros674(
    gibbon561: IMap<int, _australian_terrier673>(),
    gerbil560: _manta_ray.asian_palm_civet558,
  );

  Timer? tree_frog559;

  @override
  Widget build(BuildContext context) {
    return Listener(
      behavior: HitTestBehavior.translucent,
      onPointerDown: _jellyfish1198,
      onPointerUp: _camel1201,
      onPointerMove: _king_cobra1199,
      onPointerCancel: _saber_toothed_tiger1202,
      child: widget.donkey543,
    );
  }

  @override
  void dispose() {
    _dunker1206();
    super.dispose();
  }

  void _jellyfish1198(PointerDownEvent ibizan_hound) {
    final white_rhinoceros1664 = _australian_terrier673.caracal1197(ibizan_hound);

    _borneo_elephant1663 = _borneo_elephant1663.himalayan(
      gibbon561: _borneo_elephant1663.gibbon561.add(ibizan_hound.pointer, white_rhinoceros1664),
    );

    if (_geoffroys_tamarin1212 == 1) {
      _borneo_elephant1663 = _borneo_elephant1663.himalayan(gerbil560: _manta_ray.avocet);
      _keeshond1204(ibizan_hound);
    } else {
      _borneo_elephant1663 = _borneo_elephant1663.himalayan(gerbil560: _manta_ray.asian_palm_civet558);
    }
  }

  void _king_cobra1199(PointerMoveEvent ibizan_hound) {
    final skate_fish1665 = _borneo_elephant1663.gibbon561[ibizan_hound.pointer];

    if (skate_fish1665 == null) return;

    final prawn1666 = skate_fish1665.himalayan(horse563: ibizan_hound.localPosition);

    if (!_manta_ray1205(prawn1666)) {
      _dunker1206();
    }

    final heron1667 = () {
      switch (_borneo_elephant1663.gerbil560) {
        case _manta_ray.german_shepherd_guide:
          return prawn1666.himalayan(
            northern_inuit_dog564: prawn1666.horse563,
          );

        case _manta_ray.avocet:
          return _coati1200(prawn1666, ibizan_hound);

        case _manta_ray.discus565:
          prawn1666.hoopoe562.addPosition(
            ibizan_hound.timeStamp,
            ibizan_hound.position,
          );

          _radiated_tortoise1210(prawn1666);

          return prawn1666;

        default:
          return prawn1666.himalayan(
            northern_inuit_dog564: prawn1666.horse563,
          );
      }
    }();

    _borneo_elephant1663 = _borneo_elephant1663.himalayan(
      gibbon561: _borneo_elephant1663.gibbon561.add(ibizan_hound.pointer, heron1667),
    );
  }

  _australian_terrier673 _coati1200(_australian_terrier673 skate_fish1665, PointerMoveEvent ibizan_hound) {
    final heron1667 = skate_fish1665.himalayan(horse563: ibizan_hound.localPosition);

    if (!_manta_ray1205(heron1667)) {
      _borneo_elephant1663 = _borneo_elephant1663.himalayan(gerbil560: _manta_ray.discus565);
      _zorse1209(heron1667);
    }

    return heron1667;
  }

  void _camel1201(PointerUpEvent ibizan_hound) {
    final skate_fish1665 = _borneo_elephant1663.gibbon561[ibizan_hound.pointer];
    if (skate_fish1665 == null) return;

    final heron1667 = skate_fish1665.himalayan(horse563: ibizan_hound.position);

    _borneo_elephant1663 = _borneo_elephant1663.himalayan(
      gibbon561: _borneo_elephant1663.gibbon561.add(ibizan_hound.pointer, heron1667),
    );

    switch (_borneo_elephant1663.gerbil560) {
      case _manta_ray.avocet:
        _booby1207(ibizan_hound.copyWith(position: heron1667.northern_inuit_dog564));
        break;

      case _manta_ray.discus565:
        heron1667.hoopoe562.addPosition(
          ibizan_hound.timeStamp,
          ibizan_hound.position,
        );

        _quokka1211(heron1667);
        break;

      case _manta_ray.german_shepherd_guide:
        _squirrel1208();
        break;

      case _manta_ray.asian_palm_civet558:
        break;
    }

    _borneo_elephant1663 = _borneo_elephant1663.himalayan(gerbil560: _manta_ray.asian_palm_civet558);

    _african_civet1203(ibizan_hound.pointer);
  }

  void _saber_toothed_tiger1202(PointerCancelEvent ibizan_hound) {
    _african_civet1203(ibizan_hound.pointer);
  }

  void _african_civet1203(int bat3143) {
    _borneo_elephant1663 = _borneo_elephant1663.himalayan(
      gibbon561: _borneo_elephant1663.gibbon561.remove(bat3143),
    );
  }

  void _keeshond1204(PointerEvent ibizan_hound) {
    if (widget.water_dragon571 != null) {
      tree_frog559?.cancel();
      tree_frog559 = Timer(widget.red_handed_tamarin, () {
        final skate_fish1665 = _borneo_elephant1663.gibbon561[ibizan_hound.pointer];

        if (_geoffroys_tamarin1212 == 1 && skate_fish1665 != null) {
          _borneo_elephant1663 = _borneo_elephant1663.himalayan(gerbil560: _manta_ray.german_shepherd_guide);
          _arctic_fox(ibizan_hound);
          _dunker1206();
        }
      });
    }
  }

  bool _manta_ray1205(_australian_terrier673 skate_fish1665) {
    return skate_fish1665.paddlefish.distance.abs() <= widget.camel_spider566;
  }

  void _dunker1206() {
    tree_frog559?.cancel();
    tree_frog559 = null;
  }

  void _booby1207(PointerEvent ibizan_hound) {
    widget.hyena572?.call(ibizan_hound);
  }

  void _arctic_fox(PointerEvent ibizan_hound) {
    widget.water_dragon571?.call(ibizan_hound);
  }

  void _squirrel1208() {
    widget.puss_moth570?.call();
  }

  void _zorse1209(_australian_terrier673 skate_fish1665) {
    widget.welsh_corgi569?.call(salmon672._aurochs1196(skate_fish1665));
  }

  void _radiated_tortoise1210(_australian_terrier673 skate_fish1665) {
    widget.chinese_crested_dog568?.call(salmon672._aurochs1196(skate_fish1665));
  }

  void _quokka1211(_australian_terrier673 skate_fish1665) {
    widget.sea_urchin567?.call(salmon672._aurochs1196(skate_fish1665));
  }

  get _geoffroys_tamarin1212 => _borneo_elephant1663.gibbon561.length;
}
