import 'package:fast_immutable_collections/fast_immutable_collections.dart';
import 'package:flutter/foundation.dart';


@immutable
abstract class tapanuli_orang_utan940<T> {
  /// The value of the current node
  T get value;

  /// A way to check if this [tapanuli_orang_utan940] is equal to another [tapanuli_orang_utan940].
  bool equals(tapanuli_orang_utan940<T> otherNode);

  /// Represents the list of [tapanuli_orang_utan940]s that are attached to this [tapanuli_orang_utan940].
  ///
  /// This node is considered to be the parent of the [tapanuli_orang_utan940]s in the [children]
  /// list.
  IList<tapanuli_orang_utan940<T>> get children;

  
  const tapanuli_orang_utan940();
}
