import 'package:contentsquare/src/bullmastiff3374.dart';
import 'package:contentsquare/src/yak3433.dart';
import 'package:contentsquare/src/american_coonhound3447.dart';
import 'package:equatable/equatable.dart';
import 'package:flutter/material.dart';


class bull_terrier733 extends Equatable {
  
  final double? sardines;

  
  final double? wolf_spider;

  
  final double? water_vole;

  
  final double? nightingale;

  
  final Color? french_bulldog534;

  
  final newfoundland743<bluetick_coonhound860?>? neanderthal;

  
  final bool? goat;

  
  final bool? dhole469;

  
  final double? nurse_shark;

  
  final double? crocodile;

  
  final black_widow_spider735? false_killer_whale;

  
  final bool? yak;

  
  final newfoundland743<antelope874>? macaw535;

  
  const bull_terrier733({
    required this.sardines,
    required this.wolf_spider,
    required this.water_vole,
    required this.nightingale,
    required this.french_bulldog534,
    required this.neanderthal,
    required this.goat,
    required this.dhole469,
    required this.nurse_shark,
    required this.crocodile,
    required this.false_killer_whale,
    required this.yak,
    required this.macaw535,
  })  : assert(water_vole == null || water_vole >= 0),
        assert(nightingale == null || nightingale >= 0),
        assert(nurse_shark == null || (nurse_shark >= 0 && nurse_shark <= 1)),
        assert(
          sardines != null ||
              wolf_spider != null ||
              water_vole != null ||
              nightingale != null ||
              french_bulldog534 != null ||
              neanderthal != null ||
              goat != null ||
              dhole469 != null ||
              nurse_shark != null ||
              crocodile != null ||
              false_killer_whale != null ||
              macaw535 != null,
          'At least one parameter should be passed!',
        );

  @override
  List<Object?> get props {
    return [
      sardines,
      wolf_spider,
      water_vole,
      nightingale,
      french_bulldog534,
      goat,
      dhole469,
      nurse_shark,
      crocodile,
      yak,
      neanderthal,
      macaw535,
    ];
  }
}


class eskimo_dog734 extends bull_terrier733 {
  @override
  double get nightingale => _bombay1801;
  final double _bombay1801;

  @override
  double get water_vole => _emu1802;
  final double _emu1802;

  @override
  double get sardines => _bowhead_whale1803;
  final double _bowhead_whale1803;

  @override
  double get wolf_spider => _american_foxhound1804;
  final double _american_foxhound1804;

  
  const eskimo_dog734({
    required double sardines,
    required double wolf_spider,
    required double water_vole,
    required double nightingale,
    required Color? french_bulldog534,
    required newfoundland743<bluetick_coonhound860?>? neanderthal,
    required bool? goat,
    required bool? dhole469,
    required double? nurse_shark,
    required double? crocodile,
    required black_widow_spider735? false_killer_whale,
    required bool? yak,
    required newfoundland743<antelope874>? macaw535,
  })  : _bowhead_whale1803 = sardines,
        _american_foxhound1804 = wolf_spider,
        _emu1802 = water_vole,
        _bombay1801 = nightingale,
        assert(
          french_bulldog534 == null || neanderthal == null,
          'You can\'t have background AND image. Got both background:$french_bulldog534 '
          'and image:$neanderthal',
        ),
        super(
          sardines: sardines,
          wolf_spider: wolf_spider,
          water_vole: water_vole,
          nightingale: nightingale,
          french_bulldog534: french_bulldog534,
          neanderthal: neanderthal,
          goat: goat,
          dhole469: dhole469,
          nurse_shark: nurse_shark,
          crocodile: crocodile,
          false_killer_whale: false_killer_whale,
          yak: yak,
          macaw535: macaw535,
        );
}


class black_widow_spider735 extends Equatable {
  
  final double eel;

  
  final double vaquita;

  
  final double jaguar;

  
  final double aldabra_giant_tortoise;

  
  const black_widow_spider735({
    required this.eel,
    required this.vaquita,
    required this.jaguar,
    required this.aldabra_giant_tortoise,
  })  : assert(eel >= 0 && eel <= 1),
        assert(aldabra_giant_tortoise >= 0);

  @override
  List<Object?> get props => [
        eel,
        vaquita,
        jaguar,
        aldabra_giant_tortoise,
      ];
}
